<?php
/******************************************************************************/
//                                                                            //
//                           InstantCMS v1.10.6                               //
//                        http://www.instantcms.ru/                           //
//                                                                            //
//                   written by InstantCMS Team, 2007-2015                    //
//                produced by InstantSoft, (www.instantsoft.ru)               //
//                                                                            //
//                        LICENSED BY GNU/GPL v2                              //
//                                                                            //
/******************************************************************************/

class p_best_comments extends cmsPlugin {

    public $config = array (
        'num'   => 3,
        'title' => 'Лучшие комментарии'
    );

    public function __construct(){

        $this->info = array(
            'plugin'      => 'p_best_comments',
            'title'       => 'Лучшие комментарии',
            'description' => 'Добавляет перед общими комментариями список лучших',
            'author'      => '<a href="http://www.instantvideo.ru/" target="_blank">InstantMedia team</a>',
            'version'     => '1.1',
            'published'   => 1
        );

        $this->events = array(
            'BEFORE_SHOW_COMMENTS'
        );

        parent::__construct();

    }

    /**
     * Обработка событий
     * @param string $event
     * @param mixed $item
     * @return html
     */
    public function execute($event, $item){

        switch ($event){
            case 'BEFORE_SHOW_COMMENTS': $item = $this->getBestComments($item); break;
        }

        return $item;

    }

    private function getBestComments($item) {

        if(!$item){ return $item; }

        if(count($item)< $this->config['num']){
            return $item;
        }

        $best_comments = $item;
		usort($best_comments, function ($a, $b){
            return strcmp($b['rating'], $a['rating']);
        });

        cmsPage::initTemplate('plugins','p_best_comments.tpl')->
            assign('best_comments', array_slice($best_comments, 0, $this->config['num']))->
            assign('bc_count', $this->config['num'])->
            assign('title', $this->config['title'])->
        display('p_best_comments.tpl');

        return $item;

	}

}
